#include "testApp.h"
bool comparisonFunction(  particle * a, particle * b ) { 
	return a->pos.x < b->pos.x; 
}    

//--------------------------------------------------------------
void testApp::setup(){	
	ofBackground(255, 255, 255);
	ofSetVerticalSync(true);
	ofSetFrameRate(60);
	
	
	for (int i = 0; i < 500; i++){
        particle * p = new particle();
        myParticles.push_back(p);
        myParticles[i]->pos.set(ofRandom(400,600),0);
        myParticles[i]->vel.set(0,0);
		
		
		
		
	}
	
	VF.setupField(60,40,ofGetWidth(), ofGetHeight());
	VF.randomizeField(2.0);
	bParticlesRepel = true;
	bFade = false;
	pDraw = false;
}

//--------------------------------------------------------------
void testApp::update(){

	// on every frame 
	// we reset the forces
	// add in any forces on the particle
	// perfom damping and
	// then update
	
	sort( myParticles.begin(), myParticles.end(), comparisonFunction );               // sort them!
	
	for (int i = 0; i < myParticles.size(); i++){
        myParticles[i]->resetForce();
		
		// get the force from the vector field: 
		ofxVec2f frc;
		frc = VF.getForceFromPos(myParticles[i]->pos.x, myParticles[i]->pos.y);
		myParticles[i]->addForce(frc.x, frc.y);
		
		if (bParticlesRepel == true){
			for (int j = 0; j < i; j++){
				myParticles[i]->addRepulsionForce(*myParticles[j], 50, 0.2);
			}
		}
		
		myParticles[i]->addForce(0,0.4f);
		myParticles[i]->addDampingForce();
		myParticles[i]->update();
		
		if (myParticles[i]->pos.y > ofGetHeight()){
			myParticles[i]->pos.x = ofRandom(400,600);
			myParticles[i]->pos.y = 0;

		}
	}
	
	
	if (bFade == true) VF.fadeField(0.99f);

}

//--------------------------------------------------------------
void testApp::draw(){
	
	ofEnableAlphaBlending();
	ofSetColor(0,130,130, 200);
	if (pDraw){
	VF.draw();}
	
	ofSetColor(0x000000);
	
	for (int i = 0; i < myParticles.size(); i++){
		myParticles[i]->draw();
	}
	
	ofSetColor(0,130,130, 200);
	ofRect(30,30,300,75);
	ofSetColor(255,255,255, 230);
	ofDrawBitmapString("space to clear\ntoggle seeing vectorField 'd'\ntoggle fade 'f'\ntoggle repel 'r'", 50, 50);
	
	
	ofSetColor(255,255,130, 230);
	
}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
	
	if (key == ' '){
		VF.clear();
	} else if (key == 'f'){
		bFade = !bFade;
	} else if (key == 'd'){
		pDraw = !pDraw;
	} else if (key == 'r'){
		bParticlesRepel = !bParticlesRepel;
	}
}	

//--------------------------------------------------------------
void testApp::keyReleased  (int key){ 
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
	if (button == 0) {
		VF.addOutwardCircle((float)x, (float)y, 100, 0.29f);
	} else {
		
//		particles.erase(particles.begin());
//		particle myParticle;
//		myParticle.setInitialCondition(x,y,0,0);
//		particles.push_back(myParticle);
		
		for (int i = 0; i < myParticles.size(); i++){
			
			particle * p = new particle();
			myParticles.push_back(p);
			myParticles[i]->pos.set(x,y);
			myParticles[i]->vel.set(0,0);
		}
		
		
	}
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
}

//--------------------------------------------------------------
void testApp::mouseReleased(){
}
